/*
 * Copyright (c) 2009 Mysema Ltd.
 * All rights reserved.
 * 
 */
package com.mysema.commons.web;

import javax.servlet.http.HttpServletRequest;

import com.mysema.commons.lang.URLEncoder;

/**
 * URLBuilder provides
 *
 * @author tiwe
 * @version $Id$
 */
public class URLBuilder {

    private StringBuilder builder = new StringBuilder();;

    private boolean paramsGiven = false;

    public URLBuilder(HttpServletRequest req){
        this(req.getContextPath());
    }

    public URLBuilder(String str){
        builder.append(str);       
    }    

    public URLBuilder add(String... strings){    	
        for (String str : strings){
        	if ((builder.length() == 0 || builder.charAt(builder.length()-1) != '/') && str.charAt(0) != '/'){
                builder.append('/');
            }
            builder.append(URLEncoder.encodeURL(str));
        }    	
        return this;
    }

    public URLBuilder param(String key, String value){
        builder.append(paramsGiven ? "&" : "?");
        builder.append(key).append("=").append(URLEncoder.encodeParam(value,"UTF-8"));		
        paramsGiven = true;
        return this;
    }

    public String toString(){
        return builder.toString();
    }

}
